<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_SupplementRelPaxDist ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_SupplementRelPaxDist extends AbstractStructArrayBase
{
    /**
     * The SupplementRelPaxDist
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_SupplementRelPaxDist[]
     */
    public $SupplementRelPaxDist;
    /**
     * Constructor method for ArrayOfJP_SupplementRelPaxDist
     * @uses ArrayOfJP_SupplementRelPaxDist::setSupplementRelPaxDist()
     * @param \StructType\JP_SupplementRelPaxDist[] $supplementRelPaxDist
     */
    public function __construct(array $supplementRelPaxDist = array())
    {
        $this
            ->setSupplementRelPaxDist($supplementRelPaxDist);
    }
    /**
     * Get SupplementRelPaxDist value
     * @return \StructType\JP_SupplementRelPaxDist[]|null
     */
    public function getSupplementRelPaxDist()
    {
        return $this->SupplementRelPaxDist;
    }
    /**
     * This method is responsible for validating the values passed to the setSupplementRelPaxDist method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSupplementRelPaxDist method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSupplementRelPaxDistForArrayConstraintsFromSetSupplementRelPaxDist(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_SupplementRelPaxDistSupplementRelPaxDistItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_SupplementRelPaxDistSupplementRelPaxDistItem instanceof \StructType\JP_SupplementRelPaxDist) {
                $invalidValues[] = is_object($arrayOfJP_SupplementRelPaxDistSupplementRelPaxDistItem) ? get_class($arrayOfJP_SupplementRelPaxDistSupplementRelPaxDistItem) : sprintf('%s(%s)', gettype($arrayOfJP_SupplementRelPaxDistSupplementRelPaxDistItem), var_export($arrayOfJP_SupplementRelPaxDistSupplementRelPaxDistItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SupplementRelPaxDist property can only contain items of type \StructType\JP_SupplementRelPaxDist, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SupplementRelPaxDist value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_SupplementRelPaxDist[] $supplementRelPaxDist
     * @return \ArrayType\ArrayOfJP_SupplementRelPaxDist
     */
    public function setSupplementRelPaxDist(array $supplementRelPaxDist = array())
    {
        // validation for constraint: array
        if ('' !== ($supplementRelPaxDistArrayErrorMessage = self::validateSupplementRelPaxDistForArrayConstraintsFromSetSupplementRelPaxDist($supplementRelPaxDist))) {
            throw new \InvalidArgumentException($supplementRelPaxDistArrayErrorMessage, __LINE__);
        }
        $this->SupplementRelPaxDist = $supplementRelPaxDist;
        return $this;
    }
    /**
     * Add item to SupplementRelPaxDist value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_SupplementRelPaxDist $item
     * @return \ArrayType\ArrayOfJP_SupplementRelPaxDist
     */
    public function addToSupplementRelPaxDist(\StructType\JP_SupplementRelPaxDist $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_SupplementRelPaxDist) {
            throw new \InvalidArgumentException(sprintf('The SupplementRelPaxDist property can only contain items of type \StructType\JP_SupplementRelPaxDist, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SupplementRelPaxDist[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_SupplementRelPaxDist|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_SupplementRelPaxDist|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_SupplementRelPaxDist|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_SupplementRelPaxDist|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_SupplementRelPaxDist|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SupplementRelPaxDist
     */
    public function getAttributeName()
    {
        return 'SupplementRelPaxDist';
    }
}
